#include<bits/stdc++.h>

using namespace std;

#define ll long long

int main(){

    ll n,q,e=0,u=0,j;
    cin>>n>>q;
    vector<ll> a(n),b(n),p(q);

    for(int i=0;i<n;i++){
        cin>>a[i];
        cin>>b[i];
    }
    for(int i=0;i<q;i++){
        cin>>p[i];
    }

        for(j=0;j<n;j++){
            p[u]=p[u]-a[j];
            e+=1;
            if(j==n-1 || p[u]<=0){
                if(p[u]>0){
                    cout<<"-1"<<"\n";
                }
                else{
                    cout<<e<<"\n";
                }
                j=-1;
                u=u+1;
                e=0;
                if(u>=q){
                    return 0;
                }

            }

        }









}